% Run open_serial.m first!!


color_data = zeros(3, avg_period);

%avg_period = length(color_data(1,:));

avg_period = 100;

garbage_size = 5;

color_data = zeros(3, avg_period);

counter = 0;

raw_data = zeros(3, avg_period+garbage_size);

R_stats_log = [];
G_stats_log = [];
B_stats_log = [];


reply = input('Take a reading? Y/N [Y]: ', 's');
if isempty(reply)
    reply = 'Y';
end

while(reply == 'Y')
    fread(COM, COM.BytesAvailable);
    disp('Buffer Flushed');
    
    figure;
    hold on;
    
    raw_data = zeros(3, avg_period+garbage_size);
    counter = 0;

    % sample the data
    while (counter<avg_period+garbage_size)
    % 	wait for data
        while(COM.BytesAvailable<100)

        end
        [packet ErrorFlag]=getXBeePacket(COM);   

        %disp(i);
        %clc;
        %disp(packet.data(11:13)); %%% x,y coordinates (relayed from the vision system)
        %disp(packet.data(16:18)); %%% rgb information from photodiode

        % shift color data right
        color_data = circshift(color_data,[0 1]);

        color_data(:,1) = packet.data(16:18)';

        clf('reset');


        set(gca,'ColorOrder',[1 0 0; 0 1 0; 0 0 1],'NextPlot','ReplaceChildren')

        plot(color_data');
        drawnow;
        counter = counter + 1;
        
        clc
        fprintf( 'Remaining samples: %g \n', avg_period+garbage_size-counter )


        if (COM.BytesAvailable>2000)
            fread(COM, COM.BytesAvailable);
            disp('Buffer Flushed');
        end
    end  %while (counter<avg_period+garbage_size)

    close; %close the figure
    
    redavg = sum(color_data(1,1:avg_period))/avg_period;
    greenavg = sum(color_data(2,1:avg_period))/avg_period;
    blueavg = sum(color_data(3,1:avg_period))/avg_period;
    redstd = std(color_data(1,1:avg_period));
    greenstd = std(color_data(2,1:avg_period));
    bluestd = std(color_data(3,1:avg_period));
    
    
    fprintf( 'R avg: %4.2f Std: %4.2f \n', redavg, redstd )
    fprintf( 'G avg: %4.2f Std: %4.2f \n', greenavg, greenstd )
    fprintf( 'B avg: %4.2f Std: %4.2f \n', blueavg, bluestd )
    
    
    reply = input('Accept and log point? Y/N [Y]: ', 's');
    if isempty(reply)
        reply = 'Y';
    end
    
    if reply == 'Y'
        R_stats_log = [R_stats_log, [redavg, redstd]'];
        G_stats_log = [G_stats_log, [greenavg, greenstd]'];
        B_stats_log = [B_stats_log, [blueavg, bluestd]'];
        disp('Logged');
    end

    
    
    
    
    reply = input('Take a reading? Y/N [Y]: ', 's');
    if isempty(reply)
        reply = 'Y';
    end
    
    
end %while(reply == 'Y')



